**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
** Report ZSS_PDF_PRINT                                             **
**********************************************************************
** This is a demonstration program for printing a PDF417 bar code   **
** label via SAPscript using RBarc/PDF417 from Suchy MIPS           **
** This program prints one page of the form ZSS_PDF_FRM             **
** which includes a PDF417 label                                    **
**********************************************************************
** Copyright (C) 1997-2016 Suchy MIPS                               **
** All rights reserved.                                             **
**********************************************************************
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstraße 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
REPORT ZSS_PDF_PRINT.


CALL FUNCTION 'OPEN_FORM'
    EXPORTING
          FORM               = 'ZSS_PDF_FRM'
*          DEVICE             = 'PRINTER'
*          DIALOG             = 'X'
*          OPTIONS            = ITCPO
     EXCEPTIONS
          CANCELED           = 1
          DEVICE             = 2
          FORM               = 3
          OPTIONS            = 4
          UNCLOSED           = 5
          MAIL_OPTIONS       = 6
          OTHERS             = 7.



 CALL FUNCTION 'WRITE_FORM'
    EXPORTING
        ELEMENT                  = 'ITEM_LINE'
        WINDOW                   = 'MAIN'.



CALL FUNCTION 'CLOSE_FORM'
     EXCEPTIONS
          UNOPENED                 = 1
          BAD_PAGEFORMAT_FOR_PRINT = 2
          OTHERS                   = 3.
                                              .