**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
**   REPORT ZSS_PDF_SET                                             **
**********************************************************************
**                                                                  **
**                        RBARC/PDF417                              **
**                       for Sapscript                              **
**                             V12                                  **
**                Copyright (C) 2007-2016 Suchy MIPS                **
**                      All rights reserved                         **
**                                                                  **
**                       DEMO Version                               **
**                                                                  **
**********************************************************************
**  Serial No.: DEMO                                                **
**********************************************************************
**                     NOT FOR PRODUCTIVE USE!!!                    **
**********************************************************************
**                                                                  **
**  This is a part of RBarc/PDF417(c)                               **
**                                                                  **
**  Collects data passed form a Smartforms form, sets parameters    **
**  for the PDF-417 label and generates the PDF-417 bar code        **
**  using RBarc/PDF417 from Suchy MIPS                              **
**                                                                  **
**  The entry point is the form GEN_PDF417                          **
**                                                                  **
**  The customer is allowed to change this file and adapt it        **
**  to its own needs.                                               **
**  Read comments in the code to get familiar with what is to do.   **
**  For detailed instructions refere to the manual                  **
**                                                                  **
**  Suchy MIPS shall not be liable for errors contained herein or   **
**  for incidental consequential damages in connection with use of  **
**  thisprogram.                                                    **
**                                                                  **
**  THIS PROGRAM SHELL BE INSTALLED IN THE TEST ENVIRONMENT         **
**  AND TESTED BEFORE USING ON THE PRODUCTIVE SYSTEM                **
**                                                                  **
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstraße 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
**  Released: 10.01.2013                                            **
**  Version:  12                                                    **
**  Release:  12.0.0                                                **
**********************************************************************
**********************************************************************


REPORT ZSS_PDF_SET.


DATA: PDF(256), ECLEVEL TYPE I, ROWS TYPE I, COLUMNS TYPE I,
      ASPRATIO TYPE F, X_DIM TYPE F, Y_DIM TYPE F, TRUNCATE TYPE I,
      XPOS TYPE F, YPOS TYPE F, ROT TYPE I, POSTYP TYPE I,
      TEXT_ID(4), BCVALUE01(40), BARIDENT(10), UNIT(4),
      SMVAR1(31), SMVAR2(31), SMVAR3(31), SMVAR_N(70),
      SMCHG1 type string, SMCHG2(31), SMCHG3(31), NO_ERR_PRINT TYPE I,
      PDFVALUE01(80), PDFIDENT(10), GRAPHIC TYPE I.

*----FORM SMPDF: interface to SAPScript --------------------------------
FORM GEN_PDF417 TABLES IN_TAB STRUCTURE ITCSY
                      OUT_TAB STRUCTURE ITCSY.

*----Inititalizing buffer for variables---------------------------------
   PERFORM INIT_PDFDATA.

*----reading variables from SAPScript and writing them to the buffer----

         READ TABLE IN_TAB WITH KEY 'SMPDFVAR1'.
         PDFVALUE01 = IN_TAB-VALUE.
         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

         READ TABLE IN_TAB WITH KEY 'SMPDFVAR2'.
         PDFVALUE01 = IN_TAB-VALUE.
         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

         READ TABLE IN_TAB WITH KEY 'SMPDFVAR3'.
         PDFVALUE01 = IN_TAB-VALUE.
         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

         READ TABLE IN_TAB WITH KEY 'SMPDFVAR4'.
         PDFVALUE01 = IN_TAB-VALUE.
         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR5'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR6'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR7'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR8'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR9'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

*         READ TABLE IN_TAB WITH KEY 'SMPDFVAR10'.
*         PDFVALUE01 = IN_TAB-VALUE.
*         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.

         READ TABLE IN_TAB WITH KEY 'SMPDFIDENT'.
         PDFIDENT = IN_TAB-VALUE.
         READ TABLE IN_TAB WITH KEY 'BC_METHOD'.
         if SY-SUBRC = 0.
            if in_tab-value = 'BMP'.
               GRAPHIC = 3.
            elseif in_tab-value = 'OTF'.
               GRAPHIC = 4.
            elseif in_tab-value = 'PCL'.
               GRAPHIC = 1.
            else.
               GRAPHIC = 3. "default
            endif.
        else.
           GRAPHIC = 3. "default
        endif.

        READ TABLE IN_TAB WITH KEY 'XPOS'.
        IF SY-SUBRC = 0.
           XPOS = IN_TAB-VALUE.
        ENDIF.

        READ TABLE IN_TAB WITH KEY 'YPOS'.
        IF SY-SUBRC = 0.
           YPOS = IN_TAB-VALUE.
        ENDIF.



*----starting form which sets parameters for PDF417 and performs-------
*----bar code generating
   CASE PDFIDENT.
      WHEN 'PDF01'.
         PERFORM PDF01.
   ENDCASE.

*----passing the name of generated bar code to SAPScript----------------
   READ TABLE OUT_TAB WITH KEY 'SMPDFNAME'.
   OUT_TAB-VALUE = SMCHG1.
   MODIFY OUT_TAB INDEX SY-TABIX.
   READ TABLE OUT_TAB WITH KEY 'LINES'.
   IF SY-SUBRC = 0.
      SHIFT SMCHG2 LEFT DELETING LEADING '0'.
      SHIFT SMCHG2 LEFT DELETING LEADING SPACE.
      OUT_TAB-VALUE = SMCHG2.
      MODIFY OUT_TAB INDEX SY-TABIX.
   ENDIF.


ENDFORM.
*----END OF FORM SMPDF ------------------------------------------------

*----FORM PDF01: sets parameters for PDF417 and performs bar code gen.--
FORM PDF01.

*** GRAPHIC = 1 obsolet, don't use
*** GRAPHIC = 2 obsolet, don't use
*** GRAPHIC = 3 generates the PDF417 as SAP Graphic
*** GRAPHIC = 4 generates the PDF417 as OTF Graphic and can be
*** positioned using XPOS and YPOS
   GRAPHIC = GRAPHIC.

***Measure Units MM, CM or Inch valid for: XPOS, YPOS, X_DIM, Y_DIM
   UNIT = 'MM'.

*** POSTYP 0 = absolute, 1 = relative to the current cursor position
*** DOESN'T APPLY IF GRAPHIC = 3
   POSTYP = 1.

*** XPOS, YPOS position on the page if POSTYP = 0
*** or movement relative to the current cursor position if POSTYP = 1
*** negative values move the PDF left or up
*** postive values move the PDF right or down
*** DOESN'T APPLY IF GRAPHIC = 3
*** IF GRAPHIC = 4 AND POSTYP = 1 only XPOS applies. XPOS is then
*** a relative position to the recent cursor position.
*** IF GRAPHIC = 4 and POSTYP = 0, XPOS and YPOS applies as absolut
*** position.
   XPOS = XPOS.  YPOS = YPOS.

*** Error correction Level. Valid 0 - 8.
*** ECLEVEL > 8 causes automatic calculation of ECC Level.
*** AT Demo Version ECLEVEL will be automatically switched to 1.
   ECLEVEL = 10.

*** Number of Rows and Columns the PDF should be generated.
*** Set Rows and Columns to 0 and use ASPRATIO (label hight/label width)
*** for automatic calculation of no. of Rows and Columns for this label
   ROWS = 0. COLUMNS = 0. ASPRATIO = '0.5'.

*** X_DIM, Y_DIM: the size of the modul (smallest element of PDF).
*** usually the relation Y_DIM/X_DIM should be about 3.
    X_DIM = '0.350'. Y_DIM = '1.250'.


*** Generates truncated PDF (without Right Row Indicator and Stop
*** patterns. Truncate = 0: DON'T PRINT Truncated PDF
***           Truncate = 1: DO PRINT Truncated PDF
   TRUNCATE = 0.

*** Text_ID: identification for this PDF Label. You can define more
*** than 1 PDF Label in this program. Use different Identifier
*** for each defined label (up to 4 chars are allowed).
 TEXT_ID = 'P1'.

*** If you make mistakes in defining PDF parameters, RBarc/PDF417(c)
*** prints all errors, but it sets all wrong values to
*** default. You can print this label without error messages
*** by setting the value of NO_ERR_PRINT to 1.
*** Note: it only makes sens to set this value to 1
***       If you have errors but want to see the PDF anyway.
   NO_ERR_PRINT = 0.


*** Barcode Rotation.
*** Valid values are: 0, 90, 180 and 270.
   ROT = 0.

   PERFORM GEN_PDF.


ENDFORM.
*----END OF FORM PDF01 -------------------------------------------------

*---------------------------------------------------------------------*
*       DELETE BARCODE                                                *
* This form delets the text created by RBarc/PDF417(c)                *
* it should be performed from the SAPScript form                      *
* immediatelly after including the bar code into the form             *
*---------------------------------------------------------------------*

FORM DEL_PDF TABLES IN_TAB STRUCTURE ITCSY
                      OUT_TAB STRUCTURE ITCSY.

DATA: LANG, SMVAR_N(70), Text_ID like stxh-tdid.
TABLES: STXH.

   READ TABLE IN_TAB WITH KEY 'SMPDFNAME'.
   SMVAR_N = IN_TAB-VALUE.

  READ TABLE IN_TAB WITH KEY 'BC_METHOD'.
  IF SY-SUBRC = 0.
     IF IN_TAB-VALUE = 'OTF'.
        Text_ID = 'ADRS'.
     ENDIF.
  ELSE.
     Text_ID = 'ST'. "default
  ENDIF.


    SELECT SINGLE * FROM STXH WHERE TDOBJECT = 'TEXT'
                               AND TDID = Text_ID
                      AND TDNAME = SMVAR_N.
    IF SY-SUBRC = 0.
      LANG = STXH-TDSPRAS.
          CALL FUNCTION 'DELETE_TEXT'
               EXPORTING
                    ID        = TEXT_ID
                    LANGUAGE  = LANG
                    NAME      = SMVAR_N
                    OBJECT    = 'TEXT'
               EXCEPTIONS
                    NOT_FOUND = 1
                    OTHERS    = 2.
      ENDIF.
ENDFORM.


*---------------------------------------------------------------------*
*       DELETE BARCODE BITMAP                                         *
* This form delets the text created by RBarc+                         *
* it should be performed from the SAPScript form                      *
* immediatelly after including the bar code into the form             *
*---------------------------------------------------------------------*

FORM DEL_PDF_BMP TABLES IN_TAB STRUCTURE ITCSY
                         OUT_TAB STRUCTURE ITCSY.

  Data:
  i_name like stxbitmaps-tdname,
  i_object like stxbitmaps-tdobject,
  i_id like stxbitmaps-tdid,
  i_btype like  stxbitmaps-tdbtype,
  error like sy-subrc.

  READ TABLE IN_TAB WITH KEY 'SMPDFNAME'.
  I_NAME = IN_TAB-VALUE.


  call function 'SAPSCRIPT_DELETE_GRAPHIC_BDS'
    EXPORTING
      i_object      = 'GRAPHICS'
      i_name        = i_name
      i_id          = 'BMAP'
      i_btype       = 'BMON'
      dialog        = ''
    EXCEPTIONS
      delete_failed = 1
      not_found     = 2
      canceled      = 3
      others        = 4.

  error = sy-subrc.
ENDFORM.


*----FORM GEN_PDF: calls RBarc/PDF417(c) and generates the PDF bar code-
FORM GEN_PDF.
* smvar2 = 75.
   PERFORM PRINT_PDF
            USING    ECLEVEL ROWS COLUMNS ASPRATIO X_DIM Y_DIM UNIT
                     TRUNCATE XPOS YPOS POSTYP TEXT_ID NO_ERR_PRINT
                     GRAPHIC ROT
                     SMVAR1 SMVAR2 SMVAR3
            CHANGING SMCHG1 SMCHG2 SMCHG3.

ENDFORM.
*----END OF FORM GEN_PDF------------------------------------------------
INCLUDE ZSS_RBARCPDF.