**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
**   REPORT ZSF_PDF_SET                                             **
**********************************************************************
**                                                                  **
**                        RBARC/PDF417                              **
**                       for Smartforms                             **
**                             V12                                  **
**                Copyright (C) 2007-2016 Suchy MIPS                **
**                      All rights reserved                         **
**                                                                  **
**                       DEMO Version                               **
**                                                                  **
**********************************************************************
**  Serial No.: DEMO                                                **
**********************************************************************
**                     NOT FOR PRODUCTIVE USE!!!                    **
**********************************************************************
**                                                                  **
**  This is a part of RBarc/PDF417(c)                               **
**                                                                  **
**  Collects data passed form a Smartforms form, sets parameters    **
**  for the PDF-417 label and generates the PDF-417 bar code        **
**  using RBarc/PDF417 from Suchy MIPS                              **
**                                                                  **
**  The entry point is the form GEN_PDF417                          **
**                                                                  **
**  The customer is allowed to change this file and adapt it        **
**  to its own needs.                                               **
**  Read comments in the code to get familiar with what is to do.   **
**  For detailed instructions refere to the manual                  **
**                                                                  **
**  Suchy MIPS shall not be liable for errors contained herein or   **
**  for incidental consequential damages in connection with use of  **
**  thisprogram.                                                    **
**                                                                  **
**  THIS PROGRAM SHELL BE INSTALLED IN THE TEST ENVIRONMENT         **
**  AND TESTED BEFORE USING ON THE PRODUCTIVE SYSTEM                **
**                                                                  **
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstraße 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**  Internet: www.suchymips.de                                      **
**********************************************************************
**********************************************************************
**  Released: 16.05.2013                                            **
**  Version:  12                                                    **
**  Release:  12.0.1                                                **
**********************************************************************
**********************************************************************

REPORT ZSF_PDF_SET.


DATA: PDF(256), ECLEVEL TYPE I, ROWS TYPE I, COLUMNS TYPE I,
      ASPRATIO TYPE F, X_DIM TYPE F, Y_DIM TYPE F, TRUNCATE TYPE I,
      XPOS TYPE F, YPOS TYPE F, ROT TYPE I, POSTYP TYPE I,
      TEXT_ID(4), BCVALUE01(40), BARIDENT(10), UNIT(4),
      SMVAR1(31), SMVAR2 type string, SMVAR3(31), SMVAR_N(70),
      SMCHG1 type string, SMCHG2(31), SMCHG3(31), NO_ERR_PRINT TYPE I,
      PDFVALUE01(80), PDFIDENT(10), GRAPHIC TYPE I value 3,
      ESC(6) value '<0BMP>'.

*----FORM SMPDF: interface to SmartForms--------------------------------
FORM GEN_PDF417 USING PDFVALUE01 PDFVALUE02 PDFVALUE03 PDFVALUE04
*                 PDFVALUE05 PDFVALUE06 PDFVALUE07 PDFVALUE08
*                 PDFVALUE09 PDFVALUE10
                 PDFIDENT
           CHANGING TEXTNAME.

*----Inititalizing buffer for variables---------------------------------
   PERFORM INIT_PDFDATA.

*----reading variables from SmartForm and writing them to the buffer----

         PERFORM COLLECT_PDF USING PDFVALUE01 'LF' 'CR' '' '' ''.
         PERFORM COLLECT_PDF USING PDFVALUE02 'LF' 'CR' '' '' ''.
         PERFORM COLLECT_PDF USING PDFVALUE03 'LF' 'CR' '' '' ''.
         PERFORM COLLECT_PDF USING PDFVALUE04 'LF' 'CR' '' '' ''.



*----starting form which sets parameters for PDF417 and performs-------
*----bar code generating
   CASE PDFIDENT.
      WHEN 'PDF01'.
         ROT = 0.
         TEXT_ID = 'PD01'.
         PERFORM PDF01.
      WHEN 'PDF02'.
         ROT = 90.
         TEXT_ID = 'PD02'.
         PERFORM PDF01.

   ENDCASE.



TEXTNAME = SMCHG1.
ENDFORM.
*----END OF FORM SMPDF ------------------------------------------------

*----FORM PDF01: sets parameters for PDF417 and performs bar code gen.--
FORM PDF01.


***Measure Units MM, CM or Inch valid for: XPOS, YPOS, X_DIM, Y_DIM
  UNIT = 'MM'.

*** Error correction Level. Valid 0 - 8.
*** ECLEVEL > 8 causes automatic calculation of ECC Level.
*** AT Demo Version ECLEVEL will be automatically switched to 1.
  ECLEVEL = 10.

*** Number of Rows and Columns the PDF should be generated.
*** Set Rows and Columns to 0 and use ASPRATIO (label hight/label width)
*** for automatic calculation of no. of Rows and Columns for this label
  ROWS = 0. COLUMNS = 0. ASPRATIO = '0.5'.

*** X_DIM, Y_DIM: the size of the modul (smallest element of PDF).
*** usually the relation Y_DIM/X_DIM should be about 3.
  X_DIM = '0.350'. Y_DIM = '1.250'.


*** Generates truncated PDF (without Right Row Indicator and Stop
*** patterns. Truncate = 0: DON'T PRINT Truncated PDF
***           Truncate = 1: DO PRINT Truncated PDF
  TRUNCATE = 0.

*** Text_ID: identification for this PDF Label. You can define more
*** than 1 PDF Label in this program. Use different Identifier
*** for each defined label (up to 4 chars are allowed).
  TEXT_ID = Text_ID.

*** If you make mistakes in defining PDF parameters, RBarc/PDF417(c)
*** prints all errors, but it sets all wrong values to
*** default. You can print this label without error messages
*** by setting the value of NO_ERR_PRINT to 1.
*** Note: it only makes sens to set this value to 1
***       If you have errors but want to see the PDF anyway.
  NO_ERR_PRINT = 0.


*** Barcode Rotation.
*** Valid values are: 0, 90, 180 and 270.
  ROT = ROT.

  PERFORM GEN_PDF.



ENDFORM.

*---------------------------------------------------------------------*
*       DELETE BARCODE                                                *
* This form delets the bitmap created by RBarc/PDF417                 *
* it should be performed from the Smartforms form                     *
* immediatelly after including the bar code into the form             *
*---------------------------------------------------------------------*

FORM DEL_PDF_BMP USING SMVAR_N .

  Data:
  i_name like stxbitmaps-tdname,
  i_object like stxbitmaps-tdobject,
  i_id like stxbitmaps-tdid,
  i_btype like  stxbitmaps-tdbtype,
  error like sy-subrc.

  I_NAME = SMVAR_N.


  call function 'SAPSCRIPT_DELETE_GRAPHIC_BDS'
    EXPORTING
      i_object      = 'GRAPHICS'
      i_name        = i_name
      i_id          = 'BMAP'
      i_btype       = 'BMON'
      dialog        = ''
    EXCEPTIONS
      delete_failed = 1
      not_found     = 2
      canceled      = 3
      others        = 4.

  error = sy-subrc.
ENDFORM.


*----END OF FORM PDF01 -------------------------------------------------


*----FORM GEN_PDF: calls RBarc/PDF417(c) and generates the PDF bar code-
FORM GEN_PDF.
*   SMVAR1 = ESC.
*   smvar2 = 75.
   PERFORM PRINT_PDF
            USING    ECLEVEL ROWS COLUMNS ASPRATIO X_DIM Y_DIM UNIT
                     TRUNCATE XPOS YPOS POSTYP TEXT_ID NO_ERR_PRINT
                     GRAPHIC ROT
                     SMVAR1 SMVAR2 SMVAR3
            CHANGING SMCHG1 SMCHG2 SMCHG3.

ENDFORM.
*----END OF FORM GEN_PDF------------------------------------------------
INCLUDE ZSF_RBARCPDF.